/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

static char rcsid[]= "$Id: zwork.c,v 1.6 1995/11/05 21:06:08 jack Exp $";

#include <stdio.h>

#include "config.h"
#include "zwork.h"

struct zwork zwork;

/* Extra flags */
int Zctlesc = 0;
int Zresume = 0;
int Zcheckcrc = 0;
int Zshortcrc = 0;
int Zhidebar = 0;

/* Default wait time (1/100 sec) */
int Zrwait = 10*100;

/* Down load directory */
char *Zrdir = NULL;

/* Log file */
int Zlogtype = 0;
char *Zlog = NULL;
char *Zloghost = NULL;
FILE *Zlogfp = NULL;

/* Default attention string */
char Zattn[ZATTNLEN] = { 0 };

/* Default send flags */
char Zconv = ZCBIN;
char Zmanag = 0;
char Ztrans = 0;

/* Default number of null */
int Znulls = 0;
