/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: makeargv.h,v 1.1 1995/11/01 15:11:59 jack Exp $ */

#ifndef makeargv_h
#define makeargv_h

#ifdef __cplusplus
extern "C"
{
#endif
extern char **makeargv (char *string);
extern char **copyargv (char **argv);
extern void freeargv (char **argv);
extern char **addargv (char **baseargv, char **argv);
extern char **insertargv (char **baseargv, char **argv);
extern int countargv (char **argv);
#ifdef __cplusplus
}
#endif

#endif /* makeargv_h */
