/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: zreceive.h,v 1.1 1995/09/12 20:39:19 jack Exp $ */

#ifndef zreceive_h
#define zreceive_h

#define ERROR (-1)
#define TIMEOUT (-2)
#define RCDO (-3)
#define GCOUNT (-4)

#ifdef __cplusplus
extern "C"
{
#endif
extern int xeRSin (void);
extern int x7RSin (void);
extern int xhRSin (void);
extern int zgethdr (char *hdr);
extern int zrbhd32 (char *hdr);
extern int zrbhdr (char *hdr);
extern int zrhhdr (char *hdr);
extern int zrdata (char *buf, short length);
extern int zrdat32 (char *buf, short length);
#ifdef __cplusplus
}
#endif

#endif /* zreceive_h */
